
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


enum {
//	_xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
	_clkfreq = 240_000_000,
//	_clkfreq = 242_720_000,

};

//struct __using( "I2C slave v1.2.spin" ) i2cs;
struct __using( "stdlib.spin2" ) lib;


//===================================================================================

void  main( void )
{
    uint32_t  mode, divd, mult, divp, freq;

    _pinstart( 56, P_NCO_FREQ | P_OE | P_SYNC_IO, 100, 0x8000_0000 );
    _waitms( 200 );
    mode = _clockmode();
    printf( "\n  Default:  clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), mode );
    divd = ((mode >> 18) & 0x3f) + 1;
    mult = ((mode >> 8) & 0x3ff) + 1;
    divp = ((mode >> 4) + 1) & 0xf;
    divp = divp ? divp * 2 : 1;
    printf( " DIVD %d   MULT %d   DIVP %d\n", divd, mult, divp );

    for( freq = 320_000_000; freq >= 40_000_000; freq -= 20_000_000 )
    {
        _waitms( 200 );
        lib.pllset( freq );
        _setbaud( DEBUG_BAUD );
        mode = _clockmode();
        printf( "\n   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), mode );
        divd = ((mode >> 18) & 0x3f) + 1;
        mult = ((mode >> 8) & 0x3ff) + 1;
        divp = ((mode >> 4) + 1) & 0xf;
        divp = divp ? divp * 2 : 1;
        printf( " DIVD %d   MULT %d   DIVP %d\n", divd, mult, divp );

        do  {
            _txraw('.');
        } while( _rxraw(500) == -1 );
    }
}
